      integer function MPI_csend( mode, buf, dest, type, len )
      character*(*) mode
      integer       buf(*)
      integer       dest, type, len
c
      integer        rc
      integer        lbuf
c
      if ( mode .eq. 'blocking' ) then
         rc = MPI_cbsend(buf,dest,type,len)
      else if (mode .eq. 'nonblocking' ) then
	 rc = MPI_cnsend(buf,dest,type,len)
      else if (mode .eq. 'synchronous' ) then
         rc = MPI_cbsend(buf,dest,type,len)
         if (MPI_cbrecv(lbuf,0,MPI_AckType,4) .lt. 0) then
	    rc = -1
         endif
      endif
      MPI_csend = rc
      return
      end
c
      integer function MPI_crecv( mode, buf, source, type, maxlen )
      character*(*) mode
      integer  buf(*)
      integer  source, type
c
      integer rc
      integer lbuf
c
c   Comments:
c       We've modified the draft to treat truncation as an error.
c       
c       Some reasons are:
c       If the message is truncated, it isn't clear how the user
c       determines that.  For example, should the return length
c       be > maxlen if the message was truncated?
c
c       Current vendor implementations (including intel/nx) treat 
c       truncation as an error.
c
      if ( mode .eq. 'blocking' ) then
         rc = MPI_cbrecv(buf,source,type,maxlen)
      else if ( mode .eq. 'nonblocking' ) then
         rc = MPI_cnrecv(buf,source,type,maxlen)
      else if ( mode .eq. 'synchronous' ) then
         rc = MPI_cbrecv(buf,source,type,maxlen)
         source = MPI_infos()
         if (MPI_cbsend(lbuf,source,MPI_AckType,4) .lt. 0) then
	    rc = -1
         endif
      endif
      MPI_crecv = rc
      return
      end
